package bas.sourcecode.DevCalendar;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashSet;
import java.util.LinkedHashSet;

import org.apache.http.Consts;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeader;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;

import com.mysql.cj.api.jdbc.Statement;

import obj.DevInfo;

public class App {
	
	private static String Connection = "jdbc:mysql://202.162.79.195/devcalendar?user=devcalendar&password=9iwK8Fm801yLbWRP&useSSL=false&serverTimezone=UTC";
	private static String Token = "2mQSvqy17d0Dodi6fENsaUcSVKY2Xhh5FQ2aKLuE396"; //s4MVB0CjPyRfoxE7DFOkFgr2TR2CZy1qt6N8Bylnrpf //per
	private static LinkedHashSet<String> Person = new LinkedHashSet<String>(); //2mQSvqy17d0Dodi6fENsaUcSVKY2Xhh5FQ2aKLuE396
	private static String IgnorePerson = "karun,nungp,nutthaphons,patcharin,piyapongs,pla,sasawatt,siwatchl,sukrit,top,voravuts,wanida";
	
	public static void main(String[] args) {

	
		// read config
//		File file = new File("conf/config");
//		try {
//			BufferedReader br = new BufferedReader(new FileReader(file));
//			String line;
//			while ((line = br.readLine()) != null) 
//			{
////				System.out.println(line);
//				if (line.contains("connection"))
//					Connection = (line.substring(line.indexOf("\"") + 1, line.lastIndexOf("\"")));
//				else if(line.contains("linetoken"))
//					Token = (line.substring(line.indexOf("\"") + 1, line.lastIndexOf("\"")));
//				
//			}
//			br.close();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
		

		HashSet<Integer> ignoreDay = getWeekendDays();
		ignoreDay = getHoliday(ignoreDay);
		Connection connect = null;
		ArrayList<DevInfo> personList = new ArrayList<DevInfo>();
		
		
		try {
			Class.forName("com.mysql.cj.jdbc.Driver");
			connect = DriverManager.getConnection(Connection);

			if (connect != null) {
				System.out.println("Database Connected.");
				
				Statement s = (Statement) connect.createStatement();
				
				
				
				String sql2 = "SELECT username,user_id ";
				sql2 = sql2+" FROM devcalendar.dev_work ";  
				sql2 = sql2+" where 1 = 1   ";
				sql2 = sql2+" group by username "; 
				sql2 = sql2+" order by username,worked_on desc  ";
				
				ResultSet rec2 = s.executeQuery(sql2);
				while((rec2!=null) && (rec2.next()))
	            {
					Person.add(rec2.getString("username"));
	            }
				
				String sql = "SELECT username,DAY(worked_on) as worked_on FROM devcalendar.dev_work ";
				sql = sql+" where 1 = 1 ";
				sql = sql+" AND MONTH(worked_on) = MONTH(CURRENT_DATE()) ";
				sql = sql+" AND YEAR(worked_on) = YEAR(CURRENT_DATE()) ";
				sql = sql+" order by username,worked_on desc ";
				
				System.out.println(sql);
				
				ResultSet rec = s.executeQuery(sql);
				String tempName = "";
				int tempDay = 0;
				DevInfo person = new DevInfo();
				person.setDays(new HashSet());
				while((rec!=null) && (rec.next()))
	            {
					if(tempName.equals(rec.getString("username")) || tempName.equals(""))
					{
						//same person
						person.setName(rec.getString("username"));
						if(!ignoreDay.contains(Integer.parseInt(rec.getString("worked_on"))) && Integer.parseInt(rec.getString("worked_on")) != tempDay)
							person.getDays().add(Integer.parseInt(rec.getString("worked_on")));
						
						
						
					}else
					{
						//change person
						if(person.getName() == null)
							person.setName(tempName);
						personList.add(person);
						person = new DevInfo();
						person.setDays(new HashSet());
					}
					
					tempName = rec.getString("username");
					tempDay = Integer.parseInt(rec.getString("worked_on"));
	            }
				if(person.getName() == null)
					person.setName(tempName);
				personList.add(person);
				
				Calendar mycal = new GregorianCalendar();
				int toDay = mycal.get(Calendar.DAY_OF_MONTH);
				
				if(Person.size() != personList.size())
				{
//					System.out.println(Person.size());
//					System.out.println(personList.size());
					for(DevInfo dev : personList)
					{
						Person.remove(dev.name);
					}
					String[] ignore = IgnorePerson.split(",");
					for(int i=0;i<ignore.length;i++)
					{
						Person.remove(ignore[i]);
					}
					
				}
				for(String noDataPerson: Person)
				{
					DevInfo personData = new DevInfo();
					personData.setName(noDataPerson);
					personData.setDays(new HashSet<Integer>());
					personList.add(personData);
				}
				
				String[] sortData = new String[personList.size()];
				
				for(int i=0;i<personList.size();i++)
				{
					
					if((toDay-(personList.get(i).getDays().size()+ignoreDay.size())-2) <= 0)
						sortData[i] = "";
					else
					{
						sortData[i] = (toDay-(personList.get(i).getDays().size()+ignoreDay.size())-2) +" วัน "+personList.get(i).getName();
//						System.out.println(sortData[i]);
//						System.out.println(sortData[i]);
						if(personList.get(i).getName().equals("anans"))
							sortData[i] = (toDay-(personList.get(i).getDays().size()+ignoreDay.size())-1) +" วัน "+personList.get(i).getName();
					}
					
//					System.out.println(toDay);
//					System.out.println(personList.get(i).getDays().size());
//					System.out.println(ignoreDay.size());					
					
				}
				
				String notiMsg = "";
				Arrays.sort(sortData,Collections.reverseOrder());
				int rating = 1;
				for(String info : sortData)
				{
					if(!info.equals(""))
					{
						switch (rating) {
							case 1: notiMsg = notiMsg + info +" \uDBC0\uDCAD\uDBC0\uDCAD\uDBC0\uDCAD\r\n"; rating=rating+1; break;	
							case 2: notiMsg = notiMsg + info +" \uDBC0\uDCAD\uDBC0\uDCAD\r\n"; rating=rating+1; break;
							case 3: notiMsg = notiMsg + info +" \uDBC0\uDCAD\r\n"; rating=rating+1; break;
							default : notiMsg = notiMsg + info +" \r\n"; break;							
						}
						
						System.out.println(info);
					}
				}

				
				if(Person.size()>0)
				{
					String personMsg = "\r\nคนไม่บันทึกงานเดือนนี้!!!\r\n";
					personMsg = personMsg + "Time  : " + getCurrentTimeStamp("MM/dd HH:mm") +"\r\n";
					
					for(String noDataPerson: Person)
					{
						personMsg = personMsg + noDataPerson +" \r\n";
					}
					
					
//		    		sendNoti(personMsg);
				}
				
								
				if(!notiMsg.equals(""))
		    	{
		    		notiMsg = "\r\nคนไม่บันทึกงาน!!!\r\n" + notiMsg;
		    		notiMsg = "Time  : " + getCurrentTimeStamp("MM/dd HH:mm") + notiMsg + "\r\n";
		    		sendNoti(notiMsg);
		    	}else
		    	{
		    		notiMsg = "\uDBC0\uDC33\uDBC0\uDC33\uDBC0\uDC33";
		    		notiMsg = "\r\nทุกคนบันทึกงานเยี่ยมมาก!!!\r\n" + notiMsg;
		    		notiMsg = "Time  : " + getCurrentTimeStamp("MM/dd HH:mm") + notiMsg + "\r\n";
		    		sendNoti(notiMsg);
		    	}
				
				
			} else {
				System.out.println("Database Connect Failed.");
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		// Close
		try {
			if (connect != null) {
				connect.close();
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static HashSet<Integer> getWeekendDays() {
		
		HashSet<Integer> returnData  = new HashSet<Integer>();
		 
	    Calendar calendar = Calendar.getInstance();
	    int toDay = calendar.get(Calendar.DAY_OF_MONTH);
	    int year = calendar.get(Calendar.YEAR);
	    int month = calendar.get(Calendar.MONTH)+1;
//	    System.out.println(year+" "+month);
	    // Note that month is 0-based in calendar, bizarrely.
	    calendar.set(year, month - 1, 1);
	    int daysInMonth = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);

//	    int count = 0;
	    for (int day = 1; day <= daysInMonth; day++) {
	        calendar.set(year, month - 1, day);
	        int dayOfWeek = calendar.get(Calendar.DAY_OF_WEEK);
	        if (dayOfWeek == Calendar.SUNDAY || dayOfWeek == Calendar.SATURDAY) {
//	            count++;
	        	if(day <= toDay)
	        	{
		            returnData.add(day);
//		            System.out.println("day :" +(day));
	        	}
	            // Or do whatever you need to with the result.
	        }
	    }
	    return returnData;
	}
	
	
	public static HashSet<Integer> getHoliday(HashSet<Integer> ignoreDay) {
		
		Connection connect = null;		
		try {
			Class.forName("com.mysql.cj.jdbc.Driver");
			connect = DriverManager.getConnection(Connection);

			if (connect != null) {
				System.out.println("Database Connected.");
				
				Statement s = (Statement) connect.createStatement();
			
				String sql = "SELECT DAY(holiday) as holiday  FROM holidays ";
				sql = sql+" where 1 = 1 ";
				sql = sql+" AND MONTH(holiday) = MONTH(CURRENT_DATE()) ";
				sql = sql+" AND YEAR(holiday) = YEAR(CURRENT_DATE()) ";
				sql = sql+" AND holiday <= CURRENT_DATE() ";
				
				ResultSet rec = s.executeQuery(sql);
				
				while((rec!=null) && (rec.next()))
	            {
//	                System.out.print(rec.getString("holiday"));
					ignoreDay.add(Integer.parseInt(rec.getString("holiday")));
	            }
				
				
			} else {
				System.out.println("Database Connect Failed.");
			}

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return ignoreDay;
	}
	
	private static void sendNoti(String msg)
	    {

			try {

				HttpClient httpClient = new DefaultHttpClient();
				HttpPost postRequest = new HttpPost("https://notify-api.line.me/api/notify");
				// StringEntity input = new StringEntity(msg,"UTF-8");
				ArrayList<NameValuePair> form = new ArrayList<NameValuePair>();
				form.add(new BasicNameValuePair("message", msg));
				UrlEncodedFormEntity input = new UrlEncodedFormEntity(form, Consts.UTF_8);

				input.setContentType("application/json;charset=UTF-8");
				postRequest.setEntity(input);
				input.setContentEncoding(new BasicHeader(HTTP.CONTENT_TYPE, "application/json;charset=UTF-8"));
				postRequest.setHeader("Content-Type", "application/x-www-form-urlencoded");
				postRequest.setHeader("Authorization", "Bearer " + Token);
				postRequest.setHeader("Accept", "application/json");
				postRequest.setEntity(input);

				HttpResponse response = httpClient.execute(postRequest);

				BufferedReader br = new BufferedReader(new InputStreamReader((response.getEntity().getContent())));

				String output;

				while ((output = br.readLine()) != null) {
					System.out.println(output);
				}

				httpClient.getConnectionManager().shutdown();

			} catch (MalformedURLException e) {

				e.printStackTrace();

			} catch (IOException e) {

				e.printStackTrace();

			}
		
	    }
	   
	private static  String getCurrentTimeStamp(String format) {
		// "MM/dd HH:mm"
		SimpleDateFormat sdfDate = new SimpleDateFormat(format);// dd/MM/yyyy
		Date now = new Date();
		String strDate = sdfDate.format(now);
		return strDate;
	}
}
